// Garden Gnome Software - Skin
// Object2VR 3.0beta4/10559
// Filename: oio.ggsk
// Generated Fri Mar 7 14:46:32 2014

function object2vrSkin(player,base) {
	var me=this;
	var flag=false;
	var nodeMarker=new Array();
	var activeNodeMarker=new Array();
	this.player=player;
	this.player.skinObj=this;
	this.divSkin=player.divSkin;
	var basePath="";
	// auto detect base path
	if (base=='?') {
		var scripts = document.getElementsByTagName('script');
		for(var i=0;i<scripts.length;i++) {
			var src=scripts[i].src;
			if (src.indexOf('skin.js')>=0) {
				var p=src.lastIndexOf('/');
				if (p>=0) {
					basePath=src.substr(0,p+1);
				}
			}
		}
	} else
	if (base) {
		basePath=base;
	}
	this.elementMouseDown=new Array();
	this.elementMouseOver=new Array();
	var cssPrefix='';
	var domTransition='transition';
	var domTransform='transform';
	var prefixes='Webkit,Moz,O,ms,Ms'.split(',');
	var i;
	for(i=0;i<prefixes.length;i++) {
		if (typeof document.body.style[prefixes[i] + 'Transform'] !== 'undefined') {
			cssPrefix='-' + prefixes[i].toLowerCase() + '-';
			domTransition=prefixes[i] + 'Transition';
			domTransform=prefixes[i] + 'Transform';
		}
	}
	
	this.player.setMargins(0,0,0,0);
	
	this.updateSize=function(startElement) {
		var stack=new Array();
		stack.push(startElement);
		while(stack.length>0) {
			e=stack.pop();
			if (e.ggUpdatePosition) {
				e.ggUpdatePosition();
			}
			if (e.hasChildNodes()) {
				for(i=0;i<e.childNodes.length;i++) {
					stack.push(e.childNodes[i]);
				}
			}
		}
	}
	
	parameterToTransform=function(p) {
		var hs='translate(' + p.rx + 'px,' + p.ry + 'px) rotate(' + p.a + 'deg) scale(' + p.sx + ',' + p.sy + ')';
		return hs;
	}
	
	this.findElements=function(id,regex) {
		var r=new Array();
		var stack=new Array();
		var pat=new RegExp(id,'');
		stack.push(me.divSkin);
		while(stack.length>0) {
			e=stack.pop();
			if (regex) {
				if (pat.test(e.ggId)) r.push(e);
			} else {
				if (e.ggId==id) r.push(e);
			}
			if (e.hasChildNodes()) {
				for(i=0;i<e.childNodes.length;i++) {
					stack.push(e.childNodes[i]);
				}
			}
		}
		return r;
	}
	
	this.addSkin=function() {
		this._zoom_in=document.createElement('div');
		this._zoom_in.ggId="zoom_in";
		this._zoom_in.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._zoom_in.ggVisible=true;
		this._zoom_in.className='ggskin ggskin_svg';
		this._zoom_in.ggType='svg';
		this._zoom_in.ggUpdatePosition=function() {
			this.style[domTransition]='none';
			if (this.parentNode) {
				w=this.parentNode.offsetWidth;
				this.style.left=(-115 + w) + 'px';
				h=this.parentNode.offsetHeight;
				this.style.top=(-37 + h) + 'px';
			}
		}
		hs ='position:absolute;';
		hs+='left: -115px;';
		hs+='top:  -37px;';
		hs+='width: 32px;';
		hs+='height: 32px;';
		hs+=cssPrefix + 'transform-origin: 50% 50%;';
		hs+='visibility: inherit;';
		hs+='cursor: pointer;';
		this._zoom_in.setAttribute('style',hs);
		this._zoom_in__img=document.createElement('img');
		this._zoom_in__img.className='ggskin ggskin_svg';
		this._zoom_in__img.setAttribute('src',basePath + 'images/zoom_in.svg');
		this._zoom_in__img.setAttribute('style','position: absolute;top: 0px;left: 0px;width: 32px;height: 32px;-webkit-user-drag:none;');
		this._zoom_in__img['ondragstart']=function() { return false; };
		this._zoom_in.appendChild(this._zoom_in__img);
		this._zoom_in.onmouseover=function () {
			me._zoom_in__img.src=basePath + 'images/zoom_in__o.svg';
		}
		this._zoom_in.onmouseout=function () {
			me._zoom_in__img.src=basePath + 'images/zoom_in.svg';
			me.elementMouseDown['zoom_in']=false;
		}
		this._zoom_in.onmousedown=function () {
			me.elementMouseDown['zoom_in']=true;
		}
		this._zoom_in.onmouseup=function () {
			me.elementMouseDown['zoom_in']=false;
		}
		this._zoom_in.ontouchend=function () {
			me.elementMouseDown['zoom_in']=false;
		}
		this.divSkin.appendChild(this._zoom_in);
		this._zoom_out=document.createElement('div');
		this._zoom_out.ggId="zoom_out";
		this._zoom_out.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._zoom_out.ggVisible=true;
		this._zoom_out.className='ggskin ggskin_svg';
		this._zoom_out.ggType='svg';
		this._zoom_out.ggUpdatePosition=function() {
			this.style[domTransition]='none';
			if (this.parentNode) {
				w=this.parentNode.offsetWidth;
				this.style.left=(-77 + w) + 'px';
				h=this.parentNode.offsetHeight;
				this.style.top=(-37 + h) + 'px';
			}
		}
		hs ='position:absolute;';
		hs+='left: -77px;';
		hs+='top:  -37px;';
		hs+='width: 32px;';
		hs+='height: 32px;';
		hs+=cssPrefix + 'transform-origin: 50% 50%;';
		hs+='visibility: inherit;';
		hs+='cursor: pointer;';
		this._zoom_out.setAttribute('style',hs);
		this._zoom_out__img=document.createElement('img');
		this._zoom_out__img.className='ggskin ggskin_svg';
		this._zoom_out__img.setAttribute('src',basePath + 'images/zoom_out.svg');
		this._zoom_out__img.setAttribute('style','position: absolute;top: 0px;left: 0px;width: 32px;height: 32px;-webkit-user-drag:none;');
		this._zoom_out__img['ondragstart']=function() { return false; };
		this._zoom_out.appendChild(this._zoom_out__img);
		this._zoom_out.onmouseover=function () {
			me._zoom_out__img.src=basePath + 'images/zoom_out__o.svg';
		}
		this._zoom_out.onmouseout=function () {
			me._zoom_out__img.src=basePath + 'images/zoom_out.svg';
			me.elementMouseDown['zoom_out']=false;
		}
		this._zoom_out.onmousedown=function () {
			me.elementMouseDown['zoom_out']=true;
		}
		this._zoom_out.onmouseup=function () {
			me.elementMouseDown['zoom_out']=false;
		}
		this._zoom_out.ontouchend=function () {
			me.elementMouseDown['zoom_out']=false;
		}
		this.divSkin.appendChild(this._zoom_out);
		this._auto_rotate=document.createElement('div');
		this._auto_rotate.ggId="auto_rotate";
		this._auto_rotate.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._auto_rotate.ggVisible=true;
		this._auto_rotate.className='ggskin ggskin_svg';
		this._auto_rotate.ggType='svg';
		this._auto_rotate.ggUpdatePosition=function() {
			this.style[domTransition]='none';
			if (this.parentNode) {
				w=this.parentNode.offsetWidth;
				this.style.left=(-37 + w) + 'px';
				h=this.parentNode.offsetHeight;
				this.style.top=(-37 + h) + 'px';
			}
		}
		hs ='position:absolute;';
		hs+='left: -37px;';
		hs+='top:  -37px;';
		hs+='width: 32px;';
		hs+='height: 32px;';
		hs+=cssPrefix + 'transform-origin: 50% 50%;';
		hs+='visibility: inherit;';
		hs+='cursor: pointer;';
		this._auto_rotate.setAttribute('style',hs);
		this._auto_rotate__img=document.createElement('img');
		this._auto_rotate__img.className='ggskin ggskin_svg';
		this._auto_rotate__img.setAttribute('src',basePath + 'images/auto_rotate.svg');
		this._auto_rotate__img.setAttribute('style','position: absolute;top: 0px;left: 0px;width: 32px;height: 32px;-webkit-user-drag:none;');
		this._auto_rotate__img['ondragstart']=function() { return false; };
		this._auto_rotate.appendChild(this._auto_rotate__img);
		this._auto_rotate.onclick=function () {
			me.player.toggleAutorotate();
		}
		this._auto_rotate.onmouseover=function () {
			me._auto_rotate__img.src=basePath + 'images/auto_rotate__o.svg';
		}
		this._auto_rotate.onmouseout=function () {
			me._auto_rotate__img.src=basePath + 'images/auto_rotate.svg';
		}
		this.divSkin.appendChild(this._auto_rotate);
		this._screen_tint=document.createElement('div');
		this._screen_tint.ggId="screen_tint";
		this._screen_tint.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._screen_tint.ggVisible=false;
		this._screen_tint.className='ggskin ggskin_rectangle';
		this._screen_tint.ggType='rectangle';
		hs ='position:absolute;';
		hs+='left: 0px;';
		hs+='top:  0px;';
		hs+='width: 5001px;';
		hs+='height: 5001px;';
		hs+=cssPrefix + 'transform-origin: 50% 50%;';
		hs+='visibility: hidden;';
		hs+='background: #ffffff;';
		hs+='background: rgba(255,255,255,0.588235);';
		hs+='border: 0px solid #000000;';
		this._screen_tint.setAttribute('style',hs);
		this.divSkin.appendChild(this._screen_tint);
		this._popup_background=document.createElement('div');
		this._popup_background.ggId="popup_background";
		this._popup_background.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._popup_background.ggVisible=false;
		this._popup_background.className='ggskin ggskin_container';
		this._popup_background.ggType='container';
		this._popup_background.ggUpdatePosition=function() {
			this.style[domTransition]='none';
			if (this.parentNode) {
				w=this.parentNode.offsetWidth;
				this.style.left=(-106 + w/2) + 'px';
			}
		}
		hs ='position:absolute;';
		hs+='left: -106px;';
		hs+='top:  110px;';
		hs+='width: 204px;';
		hs+='height: 270px;';
		hs+=cssPrefix + 'transform-origin: 50% 50%;';
		hs+='visibility: hidden;';
		this._popup_background.setAttribute('style',hs);
		this._popup_loader=document.createElement('div');
		this._popup_loader__text=document.createElement('div');
		this._popup_loader.className='ggskin ggskin_textdiv';
		this._popup_loader.ggTextDiv=this._popup_loader__text;
		this._popup_loader.ggId="popup_loader";
		this._popup_loader.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._popup_loader.ggVisible=true;
		this._popup_loader.className='ggskin ggskin_text';
		this._popup_loader.ggType='text';
		hs ='position:absolute;';
		hs+='left: 0px;';
		hs+='top:  9px;';
		hs+='width: 198px;';
		hs+='height: 261px;';
		hs+=cssPrefix + 'transform-origin: 50% 50%;';
		hs+='visibility: inherit;';
		this._popup_loader.setAttribute('style',hs);
		hs ='position:absolute;';
		hs+='left: 0px;';
		hs+='top:  0px;';
		hs+='width: 198px;';
		hs+='height: 261px;';
		hs+='border: 0px solid #000000;';
		hs+='color: #000000;';
		hs+='text-align: center;';
		hs+='white-space: nowrap;';
		hs+='padding: 0px 1px 0px 1px;';
		hs+='overflow: hidden;';
		this._popup_loader__text.setAttribute('style',hs);
		this._popup_loader__text.innerHTML="";
		this._popup_loader.appendChild(this._popup_loader__text);
		this._popup_background.appendChild(this._popup_loader);
		this._close_button_background=document.createElement('div');
		this._close_button_background.ggId="close_button_background";
		this._close_button_background.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._close_button_background.ggVisible=true;
		this._close_button_background.className='ggskin ggskin_rectangle';
		this._close_button_background.ggType='rectangle';
		hs ='position:absolute;';
		hs+='left: 170px;';
		hs+='top:  -2px;';
		hs+='width: 36px;';
		hs+='height: 36px;';
		hs+=cssPrefix + 'transform-origin: 50% 50%;';
		hs+='visibility: inherit;';
		hs+='background: #000000;';
		hs+='background: rgba(0,0,0,0.54902);';
		hs+='border: 0px solid #000000;';
		hs+='border-radius: 999px;';
		hs+=cssPrefix + 'border-radius: 999px;';
		this._close_button_background.setAttribute('style',hs);
		this._popup_background.appendChild(this._close_button_background);
		this._close_popup=document.createElement('div');
		this._close_popup.ggId="close_popup";
		this._close_popup.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._close_popup.ggVisible=true;
		this._close_popup.className='ggskin ggskin_svg';
		this._close_popup.ggType='svg';
		hs ='position:absolute;';
		hs+='left: 172px;';
		hs+='top:  0px;';
		hs+='width: 32px;';
		hs+='height: 32px;';
		hs+=cssPrefix + 'transform-origin: 50% 50%;';
		hs+='visibility: inherit;';
		hs+='cursor: pointer;';
		this._close_popup.setAttribute('style',hs);
		this._close_popup__img=document.createElement('img');
		this._close_popup__img.className='ggskin ggskin_svg';
		this._close_popup__img.setAttribute('src',basePath + 'images/close_popup.svg');
		this._close_popup__img.setAttribute('style','position: absolute;top: 0px;left: 0px;width: 32px;height: 32px;-webkit-user-drag:none;');
		this._close_popup__img['ondragstart']=function() { return false; };
		this._close_popup.appendChild(this._close_popup__img);
		this._close_popup.onclick=function () {
			me._popup_background.style[domTransition]='none';
			me._popup_background.style.visibility='hidden';
			me._popup_background.ggVisible=false;
			me._popup_loader.ggText="";
			me._popup_loader.innerHTML=me._popup_loader.ggText;
			if (me._popup_loader.ggUpdateText) {
				me._popup_loader.ggUpdateText=function() {
					var hs="";
					if (hs!=me._popup_loader.ggText) {
						me._popup_loader.ggText=hs;
						me._popup_loader.innerHTML=hs;
					}
				}
			}
			me._screen_tint.style[domTransition]='none';
			me._screen_tint.style.visibility='hidden';
			me._screen_tint.ggVisible=false;
		}
		this._close_popup.onmouseover=function () {
			me._close_popup__img.src=basePath + 'images/close_popup__o.svg';
		}
		this._close_popup.onmouseout=function () {
			me._close_popup__img.src=basePath + 'images/close_popup.svg';
		}
		this._popup_background.appendChild(this._close_popup);
		this.divSkin.appendChild(this._popup_background);
		this.divSkin.ggUpdateSize=function(w,h) {
			me.updateSize(me.divSkin);
		}
		this.divSkin.ggViewerInit=function() {
		}
		this.divSkin.ggLoaded=function() {
		}
		this.divSkin.ggReLoaded=function() {
		}
		this.divSkin.ggLoadedLevels=function() {
		}
		this.divSkin.ggReLoadedLevels=function() {
		}
		this.divSkin.ggEnterFullscreen=function() {
		}
		this.divSkin.ggExitFullscreen=function() {
		}
		this.skinTimerEvent();
	};
	this.hotspotProxyClick=function(id) {
	}
	this.hotspotProxyOver=function(id) {
	}
	this.hotspotProxyOut=function(id) {
	}
	this.changeActiveNode=function(id) {
		var newMarker=new Array();
		var i,j;
		var tags=me.player.userdata.tags;
		for (i=0;i<nodeMarker.length;i++) {
			var match=false;
			if ((nodeMarker[i].ggMarkerNodeId==id) && (id!='')) match=true;
			for(j=0;j<tags.length;j++) {
				if (nodeMarker[i].ggMarkerNodeId==tags[j]) match=true;
			}
			if (match) {
				newMarker.push(nodeMarker[i]);
			}
		}
		for(i=0;i<activeNodeMarker.length;i++) {
			if (newMarker.indexOf(activeNodeMarker[i])<0) {
				if (activeNodeMarker[i].ggMarkerNormal) {
					activeNodeMarker[i].ggMarkerNormal.style.visibility='inherit';
				}
				if (activeNodeMarker[i].ggMarkerActive) {
					activeNodeMarker[i].ggMarkerActive.style.visibility='hidden';
				}
				if (activeNodeMarker[i].ggDeactivate) {
					activeNodeMarker[i].ggDeactivate();
				}
			}
		}
		for(i=0;i<newMarker.length;i++) {
			if (activeNodeMarker.indexOf(newMarker[i])<0) {
				if (newMarker[i].ggMarkerNormal) {
					newMarker[i].ggMarkerNormal.style.visibility='hidden';
				}
				if (newMarker[i].ggMarkerActive) {
					newMarker[i].ggMarkerActive.style.visibility='inherit';
				}
				if (newMarker[i].ggActivate) {
					newMarker[i].ggActivate();
				}
			}
		}
		activeNodeMarker=newMarker;
	}
	this.skinTimerEvent=function() {
		setTimeout(function() { me.skinTimerEvent(); }, 10);
		if (me.elementMouseDown['zoom_in']) {
			me.player.changeFovLog(-0.2,true);
		}
		if (me.elementMouseDown['zoom_out']) {
			me.player.changeFovLog(0.2,true);
		}
	};
	function SkinHotspotClass(skinObj,hotspot) {
		var me=this;
		var flag=false;
		this.player=skinObj.player;
		this.skin=skinObj;
		this.hotspot=hotspot;
		this.elementMouseDown=new Array();
		this.elementMouseOver=new Array();
		this.__div=document.createElement('div');
		this.__div.setAttribute('style','position:absolute; left:0px;top:0px;visibility: inherit;');
		
		this.findElements=function(id,regex) {
			return me.skin.findElements(id,regex);
		}
		
		{
			this.__div=document.createElement('div');
			this.__div.ggId="hs";
			this.__div.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
			this.__div.ggVisible=true;
			this.__div.className='ggskin ggskin_hotspot';
			this.__div.ggType='hotspot';
			hs ='position:absolute;';
			hs+='left: 74px;';
			hs+='top:  279px;';
			hs+='width: 5px;';
			hs+='height: 5px;';
			hs+=cssPrefix + 'transform-origin: 50% 50%;';
			hs+='visibility: inherit;';
			hs+='cursor: pointer;';
			this.__div.setAttribute('style',hs);
			this.__div.onclick=function () {
				me.skin._popup_background.style[domTransition]='none';
				me.skin._popup_background.style.visibility='inherit';
				me.skin._popup_background.ggVisible=true;
				me.skin._popup_loader.ggText=me.hotspot.url;
				me.skin._popup_loader.innerHTML=me.skin._popup_loader.ggText;
				if (me.skin._popup_loader.ggUpdateText) {
					me.skin._popup_loader.ggUpdateText=function() {
						var hs=me.hotspot.url;
						if (hs!=me.skin._popup_loader.ggText) {
							me.skin._popup_loader.ggText=hs;
							me.skin._popup_loader.innerHTML=hs;
						}
					}
				}
				me.skin._screen_tint.style[domTransition]='none';
				me.skin._screen_tint.style.visibility='inherit';
				me.skin._screen_tint.ggVisible=true;
				me.skin.hotspotProxyClick(me.hotspot.id);
			}
			this.__div.onmouseover=function () {
				me.player.hotspot=me.hotspot;
				me.skin.hotspotProxyOver(me.hotspot.id);
			}
			this.__div.onmouseout=function () {
				me.player.hotspot=me.player.emptyHotspot;
				me.skin.hotspotProxyOut(me.hotspot.id);
			}
			this._reaindeer_loader=document.createElement('div');
			this._reaindeer_loader__text=document.createElement('div');
			this._reaindeer_loader.className='ggskin ggskin_textdiv';
			this._reaindeer_loader.ggTextDiv=this._reaindeer_loader__text;
			this._reaindeer_loader.ggId="reaindeer_loader";
			this._reaindeer_loader.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
			this._reaindeer_loader.ggVisible=true;
			this._reaindeer_loader.className='ggskin ggskin_text';
			this._reaindeer_loader.ggType='text';
			hs ='position:absolute;';
			hs+='left: -37px;';
			hs+='top:  -87px;';
			hs+='width: 74px;';
			hs+='height: 100px;';
			hs+=cssPrefix + 'transform-origin: 50% 50%;';
			hs+='visibility: inherit;';
			hs+='cursor: pointer;';
			this._reaindeer_loader.setAttribute('style',hs);
			hs ='position:absolute;';
			hs+='left: 0px;';
			hs+='top:  0px;';
			hs+='width: 74px;';
			hs+='height: 100px;';
			hs+='border: 0px solid #000000;';
			hs+='color: #000000;';
			hs+='text-align: center;';
			hs+='white-space: nowrap;';
			hs+='padding: 0px 1px 0px 1px;';
			hs+='overflow: hidden;';
			this._reaindeer_loader__text.setAttribute('style',hs);
			this._reaindeer_loader__text.innerHTML="<iframe src=\"reindeer\/reindeer.html\" width=\"76px\" height=\"100px\" allowfullscreen=\"true\" mozallowfullscreen=\"true\" webkitallowfullscreen=\"true\" frameborder=\"0\"><\/iframe>";
			this._reaindeer_loader.appendChild(this._reaindeer_loader__text);
			this._reaindeer_loader.onclick=function () {
				me.skin._popup_background.style[domTransition]='none';
				me.skin._popup_background.style.visibility='inherit';
				me.skin._popup_background.ggVisible=true;
				me.skin._popup_loader.ggText=me.hotspot.url;
				me.skin._popup_loader.innerHTML=me.skin._popup_loader.ggText;
				if (me.skin._popup_loader.ggUpdateText) {
					me.skin._popup_loader.ggUpdateText=function() {
						var hs=me.hotspot.url;
						if (hs!=me.skin._popup_loader.ggText) {
							me.skin._popup_loader.ggText=hs;
							me.skin._popup_loader.innerHTML=hs;
						}
					}
				}
			}
			this.__div.appendChild(this._reaindeer_loader);
			this._click_plate=document.createElement('div');
			this._click_plate.ggId="click_plate";
			this._click_plate.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
			this._click_plate.ggVisible=true;
			this._click_plate.className='ggskin ggskin_rectangle';
			this._click_plate.ggType='rectangle';
			hs ='position:absolute;';
			hs+='left: -37px;';
			hs+='top:  -87px;';
			hs+='width: 75px;';
			hs+='height: 99px;';
			hs+=cssPrefix + 'transform-origin: 50% 50%;';
			hs+='opacity: 0.005;';
			hs+='visibility: inherit;';
			hs+='cursor: pointer;';
			hs+='background: #ffffff;';
			hs+='border: 1px solid #000000;';
			this._click_plate.setAttribute('style',hs);
			this._click_plate.onclick=function () {
				me.skin._popup_background.style[domTransition]='none';
				me.skin._popup_background.style.visibility='inherit';
				me.skin._popup_background.ggVisible=true;
				me.skin._popup_loader.ggText=me.hotspot.url;
				me.skin._popup_loader.innerHTML=me.skin._popup_loader.ggText;
				if (me.skin._popup_loader.ggUpdateText) {
					me.skin._popup_loader.ggUpdateText=function() {
						var hs=me.hotspot.url;
						if (hs!=me.skin._popup_loader.ggText) {
							me.skin._popup_loader.ggText=hs;
							me.skin._popup_loader.innerHTML=hs;
						}
					}
				}
			}
			this.__div.appendChild(this._click_plate);
		}
	};
	this.addSkinHotspot=function(hotspot) {
		return new SkinHotspotClass(me,hotspot);
	}
	this.addSkin();
};